"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immer_1 = require("immer");
function handleAction(ac, re, s) {
    return function (state, action) {
        if (action.type === ac.type && state) {
            if (immer_1.isDraftable(state)) {
                var draft = immer_1.createDraft(state);
                var reResult = re(draft, action);
                var finishedDraft = immer_1.finishDraft(draft);
                if (finishedDraft === state && reResult !== undefined) {
                    return reResult;
                }
                return finishedDraft;
            }
            // Support primitive-returning reducers
            return re(state, action);
        }
        return (state || s);
    };
}
exports.default = handleAction;
//# sourceMappingURL=handle-action.js.map