"use strict";
/* eslint-disable no-param-reassign */
Object.defineProperty(exports, "__esModule", { value: true });
var create_action_1 = require("./create-action");
var handle_action_1 = require("./handle-action");
var reduce_reducers_1 = require("./reduce-reducers");
test('all together (type handle)', function () {
    var inc = create_action_1.default('inc1');
    var dec = create_action_1.default('dec1');
    var add = create_action_1.default('add1');
    var state = { counter: 0 };
    var re = reduce_reducers_1.default([
        handle_action_1.default(inc, function (draft) {
            draft.counter += 1;
        }),
        handle_action_1.default(dec, function (draft) {
            draft.counter -= 1;
        }),
        handle_action_1.default(add, function (draft, _a) {
            var payload = _a.payload;
            draft.counter += payload;
        }),
    ], state);
    var actions = [inc(), dec(), dec(), inc(), inc(), add(5)];
    expect(actions.reduce(re, undefined)).toEqual({ counter: 6 });
});
test('all together (type reducers)', function () {
    var inc = create_action_1.default('inc2');
    var dec = create_action_1.default('dec2');
    var add = create_action_1.default('add2');
    var state = { counter: 0 };
    var re = reduce_reducers_1.default([
        handle_action_1.default(inc, function (draft) {
            draft.counter += 1;
        }),
        handle_action_1.default(dec, function (draft) {
            draft.counter -= 1;
        }),
        handle_action_1.default(add, function (draft, _a) {
            var payload = _a.payload;
            draft.counter += payload;
        }),
    ], state);
    var actions = [inc(), dec(), dec(), inc(), inc(), add(5)];
    expect(actions.reduce(re, undefined)).toEqual({ counter: 6 });
});
test('all together (type reduceReducers)', function () {
    var inc = create_action_1.default('inc3');
    var dec = create_action_1.default('dec3');
    var add = create_action_1.default('add3');
    var state = { counter: 0 };
    var re = reduce_reducers_1.default([
        handle_action_1.default(inc, function (draft) {
            draft.counter += 1;
        }),
        handle_action_1.default(dec, function (draft) {
            draft.counter -= 1;
        }),
        handle_action_1.default(add, function (draft, _a) {
            var payload = _a.payload;
            draft.counter += payload;
        }),
    ], state);
    var actions = [inc(), dec(), dec(), inc(), inc(), add(5)];
    expect(actions.reduce(re, undefined)).toEqual({ counter: 6 });
});
//# sourceMappingURL=reduce-reducers.test.js.map