/* eslint-disable no-param-reassign, no-console */
import * as assert from 'assert';
import { createStore } from 'redux';
import { createAction, handleAction, reduceReducers } from '.';
// Actions
const increment = createAction('increment');
const decrement = createAction('decrement');
const add = createAction('add');
const override = createAction('override');
const initialState = {
    counter: 0,
};
const reducer = reduceReducers([
    handleAction(increment, (state) => {
        state.counter += 1;
    }),
    handleAction(decrement, (state) => {
        state.counter -= 1;
    }),
    handleAction(add, (state, { payload }) => {
        state.counter += payload;
    }),
    handleAction(override, (_, { payload }) => ({
        counter: payload,
    })),
], initialState);
// Store
const store = createStore(reducer);
store.subscribe(() => console.log('New state!', store.getState()));
// Go to town!
store.dispatch(increment());
store.dispatch(increment());
store.dispatch(increment());
store.dispatch(decrement());
store.dispatch(add(10));
console.log('Final count!', store.getState().counter);
assert(store.getState().counter === 12);
//# sourceMappingURL=example.js.map