import { createDraft, finishDraft, isDraftable, } from 'immer';
export default function handleAction(ac, re, s) {
    return (state, action) => {
        if (action.type === ac.type && state) {
            if (isDraftable(state)) {
                const draft = createDraft(state);
                const reResult = re(draft, action);
                const finishedDraft = finishDraft(draft);
                if (finishedDraft === state && reResult !== undefined) {
                    return reResult;
                }
                return finishedDraft;
            }
            // Support primitive-returning reducers
            return re(state, action);
        }
        return (state || s);
    };
}
//# sourceMappingURL=handle-action.js.map